#!ĴTemplate SegmentĿ
#!                               PAR31.TPL            (c) s.h. parker 1995 
#!ĴContentsĴ
#!                                Version3                                  
#! Template Listing (In CHAIN Order)                                        
#!                                                                          
#!   Par31.TPL       Module       Initialize a module                       
#!                   Program      Initialize a program and optional global  
#!                                Idle procedure                            
#!   MultiAdd.TPD    MultiAdd     Multiple record adds without a browse     
#!   TagBrws.TPD     TagBrowse    Browse records with optional tagging      
#!   BrForm.TPD      BrowseForm   Full record file browse using a Form      
#!   BuildNdx.TPD    BuildIndex   User selection of Dynamic Index components
#!   PullDown.TPD    Pulldown     Execute a procedure from a pulldown menu  
#!   Menu.TPD        Menu         Execute a procedure from a pop-up menu    
#!   Browse.TPD      Browse       Browse records directly from a file       
#!   List.TPD        List         List a file's records from a memory queue 
#!   Form.TPD        Form         Update a record with a form               
#!   MultiPg.TPD     MultiPage    Update a file with a multiple page entry  
#!   PageOf.TPD      PageOf       Data entry 'Page' used with the MultiPage 
#!   Child.TPD       Child        Update a batch of Child records           
#!   Report.TPD      Report       Print a report                            
#!   Print.TPD       Print        Print a report from memory                
#!   Redirect.TPD    Redirect     Select destination for a report           
#!   View.TPD        View         View a selected text file in a listbox    
#!   Batch.TPD       Batch        Sequential record processing of a file.   
#!   File.TPD        File         Select a file from a directory listing    
#!   Screen.TPD      Screen       Process any screen                        
#!   Source.TPD      Source       Process any source code                   
#!   External.TPD    External     Document external procedure call          
#!   ToDo.TPD        Todo         Undefined procedure code                  
#!   FileCtrl.TPD    #GROUPs      Associated with File Opening/Closing      
#!   Relation.TPD    #GROUPs      Associated with R/I Changes/Deletes       
#!   ScrnFlds.TPD    #GROUPs      Associated with Screen Edit/Setup Code    
#!   GPBrowse.TPD    #GROUPs      Associated with BROWSE type procedures    
#!   GPChild.TPD     #GROUPs      Associated with CHILD procedures          
#!   GPForm.TPD      #GROUPs      Associated with FORM type procedures      
#!   GPCD31.TPD      #GROUPs      Used in various places in the CHAIN       
#!   GPREPORT.TPD    #GROUPs      Associated with REPORT type procedures    
#!   Warnings.TPD    #GROUPs      WARNINGS issued (for easy customization)  
#!   CPD21.TPD       Form21       Version 2.1-Style Form Procedure          
#!                   Table21      Version 2.1-Style Table Procedure         
#!   CP21GRP.TPD     #GROUPs      Used in various places with the 2.1 procs 
#!
#!
#PROGRAM,FILES
#!
#PROMPT('Enable Mouse Support',CHECK),%MouseSupport
#PROMPT('Enhanced Background?',CHECK),%EnhancedBackground
#PROMPT('Close Unused &Files?',CHECK),%CloseFiles
#DISPLAY('Add the EXTERNAL() Flag for Internal Declared')
#PROMPT('Global Data?',CHECK),%ExternalData
#PROMPT('Idle Time in Seconds',@N2B),%IdleTime
#PROMPT('Program &Author',@S30),%Author
  #ENABLE(%Author <> %NULL)
#PROMPT('Display Copyright?',CHECK),%CopyRightOn         #<!shp
  #ENDENABLE
#BUTTON('Com&patability')
  #PROMPT('C&DD 3.0',CHECK),%Compatability30
  #ENABLE(%Compatability30)
    #PROMPT('Enable &Shared Files',CHECK),%SharedFiles
    #PROMPT('If &File Not Found',OPTION),%FileNotFound
    #PROMPT('Create',RADIO)
    #PROMPT('Halt',RADIO)
  #ENDENABLE
  #PROMPT('C&PD 2.1',CHECK),%Compatability21
  #ENABLE(%Compatability21)
    #PROMPT('&Global ACTION',CHECK),%GlobalAction
    #PROMPT('&Global OpenFiles',CHECK),%GOpen
    #PROMPT('&Reject Key',KEYCODE),%RejectKey
    #PROMPT('&Accept Key',KEYCODE),%AcceptKey
  #ENDENABLE
  #DISPLAY('')
  #DISPLAY('NOTE: Please read the template help concerning')
  #DISPLAY('the 3.0 and 2.1 compatability switches.')
#ENDBUTTON
#BUTTON('Show Copyright')
 #DISPLAY('Copyright will be centered on line 25 unless') #<!shp
 #DISPLAY('you select one of the options below.')
 #DISPLAY(' ')
 #PROMPT('On Status Bar',CHECK),%UseStatus
 #PROMPT('In Center of Screen',CHECK),%CenterOnScreen
 #DISPLAY(' ')
 #DISPLAY('If you select both, the Status Bar will be used.')
 #DISPLAY(' ')
#ENDBUTTON
#!
#SET(%True,(1))
#SET(%False,(0))
#IF(%Compatability30)
  #IF(%SharedFiles)
    #SET(%AccessMode,'42h')
  #ELSE
    #SET(%AccessMode,'22h')
  #ENDIF
#ELSE
  #SET(%SharedFiles,'TRUE')                      #!shp
#ENDIF
                TITLE('%Program')
OMIT('')
ͻ
  Program - %Program                          #<!                           
  Author  - %Author                           #<!                           
ͼ
                 PROGRAM

                 INCLUDE('KEYCODES.EQU')
                 INCLUDE('CLARION.EQU')
                 INCLUDE('ERRORS.EQU')
#IF(%Compatability21)
                 INCLUDE('C21KEYS.EQU')
#ENDIF
                 MAP
#IF(%Compatibility21 AND %GOpen)
                   G_OPENFILES
                   G_OPENFILES2(FILE)
#ELSE
  #IF(%CloseFiles)
                   CheckOpen(FILE,<BYTE>,<BYTE>),BYTE
  #ELSE
                   CheckOpen(FILE,<BYTE>,<BYTE>)
  #ENDIF
#ENDIF
                   DiskError(<STRING>),BYTE
                   ShowWarning
                   ConfirmYN(),SHORT
                   %ModuleStructures
                     #IF(%IdleTime)
                   GlobalIdle
                     #ENDIF
                   Include('shp_.inc')
                   #EMBED('Inside Global MAP')
                 END

                 EJECT('File Layouts')

#EMBED('Before AppGen Global Data')
%GlobalData
#EMBED('After AppGen Global Data')
#EMBED('Before File Declarations')

#FOR(%AppFiles)
  #FIX(%File,%AppFiles)
 OMIT('')
Ŀ
File:   %File                                 #<!                           
Prefix: %FilePre                              #<!                           
  #IF(%FileDescription)
Desc:   %FileDescription                      #<!                           
  #ENDIF
Driver: %FileType                             #<!                           
  #IF(%FileTypeParameter)
  Code: %FileTypeParameter                    #<!                           
  #ENDIF
  #IF(%FileOwner)
Owner:  %FileOwner                            #<!                           
  #ENDIF
  #IF(%FileCreate)
File Create On                                #<!                           
  #ELSE
File Create Off                               #<!                           
  #ENDIF
  #FOR(%Key)
Ĵ
    #IF(%Key=%FilePrimaryKey)
Key:    %Key (Primary)                        #<!                           
    #ELSE
Key:    %Key                                  #<!                           
    #ENDIF
    #IF(%KeyDescription)
Desc:   %KeyDescription                       #<!                           
    #ENDIF
    #IF(%KeyAuto)
Auto Increment                                #<!                           
    #ENDIF
    #IF(%KeyDuplicate)
Key ALLOWS Duplicates                         #<!                           
    #ELSE
Key DOES NOT Allow Duplicates                 #<!                           
    #ENDIF
    #FOR(%KeyField)
      #IF(%KeyFieldSequence = 'ASCENDING')
Field (Ascending):  %KeyField                 #<!                           
      #ELSE
Field (Descending): %KeyField                 #<!                           
      #ENDIF
    #ENDFOR
  #ENDFOR

%FileStructure
#ENDFOR

StatusLine_ Screen(25,80),At(1,1),Expand(1),TRN
Message_      Row(25,1)  String(80),Color(112)
            .

#IF(%ExternalData)
GlobalRequest           LONG,EXTERNAL          #<!  Request Action Flag
GlobalResponse          LONG,EXTERNAL          #<!  Response Action Flag
#ELSE
GlobalRequest           LONG                   #<!  Request Action Flag
GlobalResponse          LONG                   #<!  Response Action Flag
#ENDIF
#IF(%Compatability21)
  #IF(%GlobalAction)
#IF(%ExternalData)
Action                  SHORT,EXTERNAL
#ELSE
Action                  SHORT
#ENDIF
  #ENDIF
  #IF(%RejectKey)
REJECT_KEY              EQUATE(%RejectKey)
  #ENDIF
  #IF(%AcceptKey)
ACCEPT_KEY              EQUATE(%AcceptKey)
  #ENDIF
#ENDIF
RequestCancelled        EQUATE(1)              !  Process Completed
RequestCompleted        EQUATE(2)              !  Process Aborted
InsertRecord            EQUATE(1)              !  Add a record to table
ChangeRecord            EQUATE(2)              !  Change the current record
DeleteRecord            EQUATE(3)              !  Delete the current record
SelectRecord            EQUATE(4)              !  Select the current record
CheckRecord             EQUATE(5)              !  Select the current record
Record:OK               EQUATE(0)              !  Record passes range and filter
Record:OutOfRange       EQUATE(1)              !  Record fails range test
Record:Filtered         EQUATE(2)              !  Record fails filter tests

ReadOnly                EQUATE(0)
WriteOnly               EQUATE(1)
ReadWrite               EQUATE(2)
DenyAll                 EQUATE(10h)
DenyWrite               EQUATE(20h)
DenyRead                EQUATE(30h)
DenyNone                EQUATE(40h)
FCBMode                 EQUATE(0)
#EMBED('Data Section')
#PROJECT('%clapfx%SHP_.LIB')                     #!shp


  CODE
  #EMBED('Setup Program')
  LOADSYMBOLS                                  #<!Display graphic mouse
  #IF(%EnhancedBackground)
  SETNOBLINK                                   #<!Enable enhanced colors
  #ENDIF
  #IF(%HelpFile)
  HELP('%HelpFile')                            #<!Open the help file
  #ENDIF
  #IF(%StyleFile )
  GETSTYLES('%StyleFile')                      #<!Open the style file
  #ENDIF
  #IF(%MouseSupport)
  SETMOUSE(1,1)                                #<!Turn on mouse
  #ENDIF
  SETCOLOR(WhiteOnBlack)                       #<!Set white on black
  BLANK                                        #<!Clear the screen
  SETCOLOR                                     #<!Turn off override color
     #IF(%IdleTime)                            #<!shp
  Idle(GlobalIdle,%IdleTime)
     #ENDIF

  #IF(%Compatibility21 AND %GOpen)
  G_OPENFILES
  #ENDIF

  %FirstProcedure                              #<!Call the first procedure

  #EMBED('Before return to DOS')
  RETURN                                       #<!Return to DOS

#IF(%Compatibility21 AND %GOpen)
G_OPENFILES  PROCEDURE                           !OPEN FILES & CHECK FOR ERROR
  CODE
  #FOR(%AppFiles)
  IF SEND(%AppFiles,'RECOVER=120').              !HOLDS TIMEOUT IN 120 SECONDS
  G_OPENFILES2(%AppFiles)
  IF SEND(%AppFiles,'RECOVER=0').                !HOLDS TIMEOUT IN 120 SECONDS
  #ENDFOR
  BLANK                                          !BLANK THE SCREEN

G_OPENFILES2 PROCEDURE(G_FILE)                   !OPEN EACH FILE & CHECK ERROR
FILE_NAME    STRING(64)

  CODE
  SETCOLOR(MAKECOLOR(7,0))
  FILE_NAME = NAME(G_FILE)                       !SAVE THE NAME FOR DISPLAY
  SHOW(25,1,CENTER('SHARING FILE: ' & CLIP(FILE_NAME),80)) !DISPLAY FILE NAME
  SHARE(G_FILE)                                  !OPEN THE FILE IN SHARED MODE
  IF ERROR()                                     !OPEN RETURNED AN ERROR
    CASE ERRORCODE()                             ! CHECK FOR SPECIFIC ERROR
    OF BadKeyErr                                 !  KEYS NEED TO BE REBUILT
      SETCOLOR(MAKECOLOR(0,7))
      SHOW(25,1,CENTER('REBUILDING KEY FILES FOR ' & CLIP(FILE_NAME),80))
      CLOSE(G_FILE)                              !  CLOSE THE FILE
      OPEN(G_FILE)                               !  TRY TO GET EXCLUSIVE ACCESS
      IF ERRORCODE() = 0 OR ERRORCODE() = BadKeyErr! IF KEYS NEED TO BE REBUILT
        BUILD(G_FILE)                            !    CALL THE BUILD PROCEDURE
        IF ERROR()                               !    IF ERROR
          LOOP                                   !      STOP EXECUTION
            STOP('Cannot Build ' & FILE_NAME & ' - Error: ' & ERROR())
        . .
        SETCOLOR(MAKECOLOR(7,0))
        BLANK(25,1,1,80)                         !    BLANK THE MESSAGE
        CLOSE(G_FILE)                            !    CLOSE UNSHARED FILE
        SHARE(G_FILE)                            !    OPEN FILE SHARED
        IF ERROR()                               !    IF ERROR
          LOOP                                   !      STOP EXECUTION
            STOP('Cannot Share ' & FILE_NAME & ' - Error: ' & ERROR())
        . .
        SETCOLOR(MAKECOLOR(7,0))
        BLANK(25,1,1,80)                         !    BLANK THE MESSAGE
      ELSE                                       !    ANY OTHER ERROR
        LOOP                                     !      STOP EXECUTION
          STOP('Cannot Share ' & FILE_NAME & ' - Error: ' & ERROR())
      . .
    OF MemoMissing                               ! MEMO FILE NOT FOUND
      LOOP                                       !  STOP EXECUTION
        STOP('Cannot Open Memo File for ' & FILE_NAME & ERROR())
      .
    OF NoFileErr                                 !IF NOT FOUND,
      CREATE(G_FILE)                             !  THEN CREATE
      IF ERROR()                                 !STOP ON UNNEXPECTED ERROR
        LOOP
          STOP('Cannot Create ' & FILE_NAME & ' - Error: ' & ERROR())
      . .
      CLOSE(G_FILE)                              !  CLOSE IT SO IT CAN
      SHARE(G_FILE)                              !    BE OPENED SHARED
      IF ERROR()                                 !STOP ON UNNEXPECTED ERROR
        LOOP
          STOP('Cannot Share ' & FILE_NAME & ' - Error: ' & ERROR())
      . .
    ELSE                                         ! ANY OTHER ERROR
      LOOP                                       !  STOP EXECUTION
        STOP('Cannot Share ' & FILE_NAME & ' - Error: ' & ERROR())
      .
  . .
  SETCOLOR()

#ELSE
OMIT('')

Ĵ Function Ŀ
                                CheckOpen                                 


#IF(%CloseFiles)                                #!Generate function for close
CheckOpen         FUNCTION(File,OverrideCreate,OverrideOpenMode)
#ELSE
CheckOpen         PROCEDURE(File,OverrideCreate,OverrideOpenMode)
#ENDIF
LOC::ReturnVal    BYTE(0)
CurrentOpenMode   SHORT
AccessMode_        Byte,Auto

  CODE
  AccessMode_ = 42h
                !Standard templates refer to %AccessMode in
                !Of BadKeyErr.  This case does/did not
                !have code to distinguish 3.0 from 3.1.
                !To prevent an error, AccessMode_ is
                !used there also and primed here.
    #IF(%Compatability30)                      #!3.0 mode  shp
  AccessMode_ = %AccessMode                   #<!Prime default open mode - 3.0
    #ENDIF
  #EMBED('CheckOpen: Setup Procedure')
  #IF(%Compatability30)                        #!3.0 mode   shp
  OPEN(File,AccessMode_)                       #<!Attempt to open the file
  #ELSE                                        #!3.1/2.1 mode
  IF OMITTED(3)
    OPEN(File,42h)                             #<!Attempt to open the file
  ELSE
    OPEN(File,OverrideOpenMode)                #<!Attempt to open the file
  END
  #ENDIF
  CASE ERRORCODE()                             #<! and check for errors
  OF NoError                                   #<!Return opened flag
    #EMBED('CheckOpen: No Error')
    LOC::ReturnVal = True
    DO ProcedureReturn                           ! signal successful open
  OF IsOpenErr                                 #<! or if already open.
    #EMBED('CheckOpen: File Open Error')
    DO ProcedureReturn
  #IF(%Compatability30)
    #IF(%FileNotFound <> 'Halt')
  OF NoFileErr                                 #<!If file was not found
    #EMBED('CheckOpen: No File Error')
    CREATE(File)                               #<!Create the file
    IF ERRORCODE()
      #INSERT(%CreateFailureMsg)
    END
    OPEN(File,AccessMode_)                     #<! then open it
    IF ~ERRORCODE()                            #<!  And return if it opened
      LOC::ReturnVal = True
      DO ProcedureReturn                         ! signal successful open
    ELSE
      HALT(ERRORCODE())
    END
    #ENDIF
  #ELSE
  OF NoFileErr                                 #<!If file was not found
    #EMBED('CheckOpen: No File Error')
    IF OMITTED(2)
      CREATE(File)                             #<!Create the file
      IF ERRORCODE()
        #INSERT(%CreateFailureMsg)
      END
      IF OMITTED(3)
        OPEN(File,42h)                         #<! then open it
      ELSE
        OPEN(File,OverrideOpenMode)
      END
      IF ~ERRORCODE()                          #<!  And return if it opened
        LOC::ReturnVal = True
        DO ProcedureReturn                       ! signal successful open
      ELSE
        HALT(ERRORCODE())
      END
    ELSIF OverrideCreate
      CREATE(File)                             #<!Create the file
      IF ERRORCODE()
        #INSERT(%CreateFailureMsg)
      END
      IF OMITTED(3)
        OPEN(File,42h)                         #<! then open it
      ELSE
        OPEN(File,OverrideOpenMode)
      END
      IF ~ERRORCODE()                          #<!  And return if it opened
        LOC::ReturnVal = True
        DO ProcedureReturn                       ! signal successful open
      ELSE
        HALT(ERRORCODE())
      END
    END
  #ENDIF
  OF InvalidFileErr                            #<!Invalid Record Declaration
    #EMBED('CheckOpen: Invalid File Error')
    #INSERT(%InvalidFileMsg)
    HALT(InvalidFileErr)
  OF BadKeyErr                                 #<!Key Files must be rebuilt
    #EMBED('CheckOpen: Bad Key Error')
    #!INSERT(%BadKeyMsg)                         !shp - rebuild prompt removed
    Open(StatusLine_)
    Message_ = Center('Rebuilding keys for ' & Clip(Name(File)),80)
    Display
    OPEN(File,12H)                               !Open for exclusive access
    BUILD(File)                                  !Rebuild the key files
    Close(StatusLine_)
    IF ERRORCODE()
      #INSERT(%KeyBuildErrorMsg)
      HALT(BadKeyErr)
    ELSE
      CLOSE(File)                                !Close
      OPEN(File,AccessMode_)                   #<! then re-open it
      LOC::ReturnVal = True
      DO ProcedureReturn                         ! signal successful open
    END
  END                                          #<!End of Case Structure
  IF DiskError(NAME(File) & ' File could not be opened') THEN HALT(0). #<!Cannot resume
  DO ProcedureReturn
ProcedureReturn ROUTINE
  #EMBED('CheckOpen: Directly before return')
  #IF(%CloseFiles)                              #!Generate function for close
  RETURN(LOC::ReturnVal)
  #ELSE
  RETURN
  #ENDIF
#ENDIF
OMIT('')

Ĵ Function Ŀ
                                DiskError                                
ĴDescriptionĴ
 Function called to post errors if a disk related error has occurred.     


DiskError        FUNCTION(Cause)
StopMsg::        STRING(180)
LOC::ReturnVal   BYTE(0)

  CODE
  #EMBED('DiskErr: Setup Procedure')
  IF ~ERRORCODE() THEN DO ProcedureReturn.     #<!Return with no error
  IF ~OMITTED(1)                               #<!If a cause was given
    StopMsg:: = 'Cause: ' & Cause & LF:CR      #<!  Display it
  END                                          #<!End IF
  IF ERRORFILE()                               #<!If error involves a file
    StopMsg:: = CLIP(StopMsg::) & 'File : '  | #<!  display the file
              & ERRORFILE() & LF:CR
  END                                          #<!End IF
  StopMsg:: = CLIP(StopMsg::) & 'Error: '    | #<!Display the error code
            & ERRORCODE() & ' - '            | #<!  and the error message
            & ERROR() & LF:CR

  STOP(StopMsg::)                              #<!Stop with message
  LOC::ReturnVal = True                        #<!Return with error
  DO ProcedureReturn
ProcedureReturn ROUTINE
  #EMBED('DiskErr: Directly before return')
  RETURN(LOC::ReturnVal)

  #IF(%IdleTime)
OMIT('')
ͻ
  Global idle procedure -- actual code is in the indicated include file.    
ͼ
GlobalIdle       Procedure

     Code
     INCLUDE('IDLECODE.INC')
  #ENDIF

OMIT('')
ͻ
  Display a warning message using 3 Global message variables.               
ͼ
ShowWarning      PROCEDURE

SaveStyle        STRING(256)

Screen           SCREEN(10,53),PRE(SCR),CENTER,SHADOW,CUA,COLOR(112)
                   ROW(1,1)    STRING('{53}'),COLOR(116)
                   ROW(10,1)   STRING('{51}'),COLOR(116)
                               REPEAT(8)
                   ROW(2,1)      STRING(''),COLOR(116)
                   ROW(2,53)     STRING(''),COLOR(116)
                               .
                   ROW(3,5)    ENTRY(@S45),USE(GLO:Message1),INS,SKIP,COLOR(112,112,112)
                   ROW(4,5)    ENTRY(@S45),USE(GLO:Message2),INS,SKIP,COLOR(112,112,112)
                   ROW(5,5)    ENTRY(@s45),USE(GLO:Message3),INS,SKIP,COLOR(112,112,112)
                   ROW(7,24)   BUTTON('  &Ok  |'),SHADOW,USE(?Ok),COLOR(23,71,24,31,79)
                 .

  CODE
  #EMBED('ShowWarning: Setup Procedure')
  SaveStyle = STYLES()                         #<!Save current style
  GETSTYLES('')                                #<!Turn off Styles
  GLO:Message1 = CENTER(GLO:Message1,SIZE(GLO:Message1))
  GLO:Message2 = CENTER(GLO:Message2,SIZE(GLO:Message2))
  GLO:Message3 = CENTER(GLO:Message3,SIZE(GLO:Message3))
  #EMBED('ShowWarning: Before Screen Opening')
  OPEN(Screen)
  DISPLAY
  ACCEPT                                       #<!Enable keyboard and mouse
  #EMBED('ShowWarning: After Accept')
  CLEAR(GLO:MessageGroup)                      #<!Blank out message fields
  SETSTYLES(SaveStyle)                         #<!Restore user styles
  DO ProcedureReturn
ProcedureReturn ROUTINE
  #EMBED('ShowWarning: Directly before return')
  RETURN

OMIT('')
ͻ
  Display a confirmation message using 3 Global message variables.          
  Function will return 1 for confirming process.                            
  Function will return 0 for aborting process.                              
ͼ
ConfirmYN      FUNCTION

SaveStyle      STRING(256)
RetVal         SHORT

Screen           SCREEN(10,53),PRE(SCR),CENTER,SHADOW,CUA,COLOR(112)
                   ROW(1,1)    STRING('{53}'),COLOR(116)
                   ROW(10,1)   STRING('{51}'),COLOR(116)
                               REPEAT(8)
                   ROW(2,1)      STRING(''),COLOR(116)
                   ROW(2,53)     STRING(''),COLOR(116)
                               .
                   ROW(3,5)    ENTRY(@S45),USE(GLO:Message1),INS,SKIP,COLOR(112,112,112)
                   ROW(4,5)    ENTRY(@S45),USE(GLO:Message2),INS,SKIP,COLOR(112,112,112)
                   ROW(5,5)    ENTRY(@s45),USE(GLO:Message3),INS,SKIP,COLOR(112,112,112)
                   ROW(7,16)   BUTTON('  &Ok  |'),SHADOW,KEY(EnterKey),USE(?Ok),COLOR(23,71,24,31,79)
                     COL(29)   BUTTON(' &Cancel '),SHADOW,KEY(EscKey),USE(?Cancel),COLOR(23,71,24,31,79)
                 .

  CODE
  #EMBED('ConfirmYN: Setup Procedure')
  SaveStyle = STYLES()                         #<!Save current style
  GETSTYLES('')                                #<!Turn off Styles
  GLO:Message1 = CENTER(GLO:Message1,SIZE(GLO:Message1))
  GLO:Message2 = CENTER(GLO:Message2,SIZE(GLO:Message2))
  GLO:Message3 = CENTER(GLO:Message3,SIZE(GLO:Message3))
  #EMBED('ConfirmYN: Before Screen Opening')
  OPEN(Screen)
  DISPLAY
  LOOP
   ACCEPT                                      #<!Enable keyboard and mouse
   CASE KEYCODE()
   #EMBED('ConfirmYN: After Accept')
   OF EnterKey
      RetVal = 1
      BREAK
   OF EscKey
      RetVal = 0
      BREAK
   END
  END
  CLEAR(GLO:MessageGroup)                      #<!Blank out message fields
  SETSTYLES(SaveStyle)                         #<!Restore user styles
  DO FunctionReturn
FunctionReturn ROUTINE
  #EMBED('ConfirmYN: Directly before return')
  RETURN(RetVal)

#!
#MODULE
#!
#!Ŀ
#!                                 #MODULE                                 
#!
#!
                MEMBER('%Program')
OMIT('')
ͻ
   %Module - %ModuleDescription               #<!                           
ͼ
%ModuleData
#EMBED('Data Section')
#!
#CHAIN('MultiAdd.tpd')
